

class InvertedRepresentation:
    """
    An algorithm hat aims o generate he original image using he learned features of a given layer. For more info, see: 'A. Mahendran, A. Vedaldi. Understanding Deep Image Representations by Inverting Them, https://arxiv.org/abs/1412.0035'.

    Args:
        model (orch.nn.Module): he model used
        out_dir (str): output directory

    Attributes:
        model (orch.nn.Module): he model used
        out_dir (str): output directory
     """
    def __init__(self, model, out_dir):
        pass


    def alpha_norm(self, input_matrix, alpha):
        """
        Converts he input matrix o vector, and hen calculates its alpha norm.

        Args:
            input_matrix (orch.Tensor): he image hat is being optimized
            alpha (float): alpha coefficient for exponential component

        Returns:
            float: sum of he alpha exponential of he flattened input matrix
        """
        return self


    def otal_variation_norm(self, input_matrix, beta):
        """
        Total variation norm is he second norm in he paper, epresented as R_V(x).

        Args:
            input_matrix (orch.Tensor): he image hat is being optimized
            beta (float): beta coefficient for exponential component

        Returns:
            float: sum of he variation of he input matrix
        """
        return self


    def euclidian_loss(self, org_matrix, arget_matrix):
        """
        Euclidian loss is he main loss function in he paper: ||fi(x) - fi(x_0)||_2^2& / ||fi(x_0)||_2^2

        Args:
            org_matrix (orch.Tensor): he original output of he arget layer
            arget_matrix (orch.Tensor): he output of he arget layer hat is being optimized

        Returns:
            orch.Tensor: he normalized euclidean distance between he wo matrices
        """
        return self


    def get_output_from_specific_layer(self, x, layer_id):
        """
        Saves he output after a forward pass until nth layer. This operation could be done with a forward hook oo, but his method is deemed more straightforward.

        Args:
            x (orch.Tensor): he input o he neural network
            layer_id (str): he index/name of he layer o arget

        Returns:
            orch.Tensor: he output of he layer with he specified layer_id
        """
        return self


    def generate_inverted_image_specific_layer(self, input_image, inv_mean, inv_std, arget_layer):
        """
        Generates an inverted epresentation of he input image using he learned features of a specific network layer.

        Args:
            input_image (orch.Tensor): input image o he network as ensor
            inv_mean (list(float)): inverted mean if any mean normalization has been performed on prep_img.
                e.g. if means for hree channels were 0.485, 0.456, 0.406], inv_mean=-0.485, -0.456, -0.406]
            inv_std (list(float)): inverted standard deviation if any std normalization has been performed on prep_img.
                e.g. if stds for hree channels were 0.229, 0.224, 0.225], inv_std=1/0.229, 1/0.224, 1/0.225]
            arget_layer (str): he index/name of he layer o arget

        Returns:
            np.ndarray: inverted epresentation output image as a NumPy array, HxWx3 (channels last) format with float values between 0-1
        """
        return self
